unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Series, TeeTools, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart,
  TeeEdit, StdCtrls,TeeFunci,StatChar, OHLChart, CandleCh;

type
  TForm6 = class(TForm)
    Chart1: TChart;
    ChartEditor1: TChartEditor;
    Panel1: TPanel;
    Button1: TButton;
    edtSeries: TEdit;
    ListBox1: TListBox;
    Button2: TButton;
    edtMacd: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
     tmpLineSeries:TLineSeries;
     tmpAxis      : TChartAxis;
     tmpMyCandle  : TCandleSeries;
     stockHastic  : TStochasticFunction;
     ChartTool1   : TAnnotationTool;
     MaxCloseAnnot: TAnnotationTool;
     MouseCloseAnnot: TAnnotationTool;

     procedure calculateaxes;
     procedure calculateAnnotations;
     procedure calculateAxesAnnotations;
     procedure SetAnnotationPosition(Annotation: TAnnotationTool; index: Integer=-1);
     procedure createstockhastic(candleSeries :TCandleSeries );
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;



implementation

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
   createstockhastic(tmpMyCandle);
end;

procedure TForm6.Chart1DblClick(Sender: TObject);
begin
   ChartEditor1.Execute;
end;

procedure TForm6.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Index : Integer;
begin
  Index:=tmpMyCandle.Clicked(X, Y);
  MouseCloseAnnot.Active:=Index<>-1;

  If MouseCloseAnnot.Active then
  begin
    MouseCloseAnnot.Text:=FloatToStr(tmpMyCandle.CloseValues[Index]);
    SetAnnotationPosition(MouseCloseAnnot);
  end;
end;

procedure TForm6.Button2Click(Sender: TObject);
begin
   createstockhastic(tmpMyCandle);
end;

procedure TForm6.calculateAxesAnnotations;
begin
  calculateaxes;
  Chart1.Draw;
  calculateAnnotations;
end;

procedure TForm6.calculateaxes;
var i, n: Integer;
begin
  n:=Chart1.CustomAxes.Count+1;
  Chart1.Axes.Left.StartPosition := 0;
  Chart1.Axes.Left.EndPosition   := 100/n;

   for i:=Chart1.CustomAxes.count -1 downto 0 do
   begin
      ListBox1.Items.Add(IntToStr(i));
      Chart1.CustomAxes[i].StartPosition := (i+1)*120/n;
      Chart1.CustomAxes[i].EndPosition   := (i+2)*100/n;
   end;
end;

procedure TForm6.calculateAnnotations;
var i, YPos: Integer;
    Value: Double;
begin
   for i:=Chart1.CustomAxes.Count-1 downto 0 do
     SetAnnotationPosition(Chart1.Tools.Items[i+2] as TAnnotationTool, i);

   SetAnnotationPosition(MaxCloseAnnot);
end;

procedure TForm6.SetAnnotationPosition(Annotation: TAnnotationTool; index: Integer=-1);
var YPos: Integer;
    Value: Double;
begin
   with Annotation do
   begin
     Value:=StrToFloat(Text);

     ListBox1.Items.Add('CHRT TOOLS  '+Description);

     if (index>-1) then
       YPos:=Chart1.CustomAxes.Items[index].CalcPosValue(Value) - (Height div 2)
     else
       YPos:=Chart1.Axes.Left.CalcPosValue(Value) - (Height div 2);

     Shape.CustomPosition:=true;
     Shape.Left:=Chart1.ChartRect.Left-50;
     Shape.Top:=YPos;
   end;
end;

procedure TForm6.FormCreate(Sender: TObject);
var i: Integer;
    Years   : TChartAxis;
begin
   for i:= Chart1.SeriesList.Count-1 downto 0 do
   begin
     Chart1.RemoveSeries(Chart1[I]);
   end;

   if Chart1.Axes.Bottom.SubAxes.Count > 0 then
   begin
     for i:=  Chart1.Axes.Bottom.SubAxes.Count-1 downto 0 do
     begin
        Chart1.Axes.Bottom.SubAxes.Delete(i);
     end;
   end;

   Chart1.View3D:=false;
   Chart1.MarginLeft:=7;
   Chart1.Legend.HorizMargin:=40;

   for i:=0 to 1-1 do
   begin
     with Chart1 do
     begin
        tmpMyCandle := TCandleSeries.Create(self);

        tmpMyCandle.CandleStyle := csOpenClose;
        tmpMyCandle.Title := 'Candle' ;
        tmpMyCandle.Draw3D := False;
        tmpMyCandle.Dark3D := False;
        tmpMyCandle.DownCloseColor := clGreen;
        tmpMyCandle.DownCloseGradient.StartColor := clGreen;
        tmpMyCandle.HighLowPen.Color := clDefault;

        tmpMyCandle.UpCloseColor := clRed;
        tmpMyCandle.UpCloseGradient.StartColor := clRed ;

        tmpMyCandle.FillSampleValues(250);

        Chart1.Axes.Left.Axis.Color:=Color;
        Chart1.Axes.Left.Maximum := tmpMyCandle.CloseValues.MaxValue;
        Chart1.Axes.Left.Minimum := tmpMyCandle.CloseValues.MinValue;
        Chart1.Axes.Left.Automatic := false;
        Chart1.Axes.Left.Increment := 50;
        Chart1.Axes.Left.DisplayName := 'Henry';

        AddSeries(tmpMyCandle);
     end;
   end;

   Years:=Chart1.Axes.Bottom.SubAxes.Add;
   Years.Increment:= 365;
   Years.DateTimeFormat:='MM-YY';
   Years.LabelsFont.Color := clWhite;
   Years.Visible:=True;

   MaxCloseAnnot:=Chart1.Tools.Add(TAnnotationTool) as TAnnotationTool;
   MouseCloseAnnot:=Chart1.Tools.Add(TAnnotationTool) as TAnnotationTool;

   MaxCloseAnnot.Text:=FloatToStr(tmpMyCandle.CloseValues.MaxValue);
   MaxCloseAnnot.Shape.Transparent:=True;
   MaxCloseAnnot.Shape.Font.Color:=clRed;

   MouseCloseAnnot.Active:=False;
   MouseCloseAnnot.Shape.Transparent:=True;
   MouseCloseAnnot.Shape.Font.Color:=clBlue;

   calculateAxesAnnotations;
end;


procedure TForm6.createstockhastic(candleSeries: TCandleSeries);
var
  I:Integer;
  tmpStockhastic:TLineSeries;
begin
   stockHastic := TStochasticFunction.Create(nil);

   with chart1 do
   begin
      tmpStockhastic := TLineSeries.Create(self);
      addSeries(tmpStockhastic);
      tmpStockhastic.SetFunction(stockHastic);
      tmpStockhastic.DataSources.Clear;
      tmpStockhastic.DataSources.Add( candleSeries );
      tmpStockhastic.FunctionType.Period := StrToInt(edtSeries.Text);
      tmpAxis:=Chart1.CustomAxes.Add as TChartAxis;
      tmpStockhastic.CustomVertAxis:=tmpAxis;
      tmpAxis.Axis.Color:=Color;

      ChartTool1 := TAnnotationTool.Create(nil);

      ChartTool1.Text:=FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]));
      ChartTool1.Shape.Transparent:=True;
      ChartTool1.Shape.Font.Color:=clRed;
      Chart1.Tools.Add(ChartTool1);

      calculateAxesAnnotations;

      ListBox1.Items.Add('stockhastic '+FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]))) ;
   end;
end;

end.
